<?php
// edit main page
$page['header'] = LBL_EDIT;
$page['javascript'] = "<script src='javascript/edit.js' type='text/javascript'></script>\n";
$page['crumbs'][] = 'teams';
$page['content'] = "";

//$page['content'] .= "<pre>" . print_r($_POST, true) . "</pre>\n";

$group_id = array_key_exists('group_id', $_POST) ? $_POST['group_id'] : NULL;
$control = array_key_exists('control', $_POST) ? $_POST['control'] : NULL;
$inform = array_key_exists('inform', $_POST) ? $_POST['inform'] : NULL;
$d2 = array_key_exists('d2', $_POST) ? $_POST['d2'] : NULL;
$group_descr = array_key_exists('group_descr', $_POST) ? substr(stripslashes($_POST['group_descr']), 0, 254) : NULL;
$group_vis = array_key_exists('group_vis', $_POST) ? $_POST['group_vis'] : 'yes';
$subject = array_key_exists('subject', $_POST) ? stripslashes($_POST['subject']) : NULL;
$body = array_key_exists('body', $_POST) ? stripslashes($_POST['body']) : NULL;

$gr = new_grouper();
if (!$gr->isConnected()) {
  $page['errors'][] = ERROR_GROUPER_CONNECT;
  return;
}

if (!$group = $gr->getGroup($group_id)) {
  $page['errors'][] = ERROR_GROUPER_COMMUNICATE;
  return;
}

if (!$control) {
  $privs = $gr->getSubjectGroupPrivileges('GrouperAll', $group_id);
  //$page['content'] .= "getSubjectGroupPrivileges<pre>" . var_export($privs, true) . "</pre>\n";

  $group_vis = in_array('view', $privs) ? "yes" : "no";

  $page['content'] .= LBL_EDIT_CONTENT;
  $page['content'] .= "<form method='post'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $group['id'] . "'>";
  $page['content'] .= "<table class='find'>\n";
  $page['content'] .= "<tr><td>" . LBL_EDIT_FORM_NAME . "</td><td>" . htmlspecialchars($group['name']) . "</td></tr>\n";
  $page['content'] .= "<tr><td>" . LBL_EDIT_FORM_DESCR . "</td><td><textarea name='group_descr' cols='40'>" . htmlspecialchars($group['description']) . "</textarea></td><td>" . LBL_EDIT_FORM_DESCR_COMMENT . "</td></tr>\n";
  $page['content'] .= "<tr><td>" . LBL_EDIT_FORM_VIS . "</td>";
  $page['content'] .= "<td><input name='group_vis' type='radio' value='yes'" . ($group_vis == 'yes'?' checked':'') . "> " . LBL_EDIT_FORM_VIS_YES;
  $page['content'] .= " <input name='group_vis' type='radio' value='no'" . ($group_vis == 'no'?' checked':'') . "> " . LBL_EDIT_FORM_VIS_NO . "</td>";
  $page['content'] .= "<td></td></tr>\n";
  $page['content'] .= "<tr><td></td><td>";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_EDIT_FORM_ACTION . "'>\n";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_EDIT_FORM_DELETE . "'>\n";
  $page['content'] .= "<a href='teams'>" . LBL_EDIT_FORM_CANCEL . "</a>\n";
  $page['content'] .= "</td></tr>\n";
  $page['content'] .= "</table>\n";
  $page['content'] .= "</form>\n";

} else if ($control == LBL_EDIT_FORM_ACTION) {

  $group = $gr->getGroup($group_id);
  $new_group = $gr->updateGroup($group_id, $group['name'], $group_descr);

  if ($group_vis == 'yes') {
    $gr->setPrivilege($group_id, 'GrouperAll', 'view', TRUE);
  } else {
    $gr->setPrivilege($group_id, 'GrouperAll', 'view', FALSE);
  }

  //$page['content'] .= LBL_EDIT_SUCCESS;
  //$page['content'] .= "<pre>" . print_r($new_group, true) . "</pre>\n";

  header("location: teams");
  return; 

} else if ($control == LBL_EDIT_FORM_DELETE && !$d2) {
  if (!$subject) $subject = sprintf(LBL_EDIT_FORM_DEFAULT_SUBJECT, $group['name']);
  if (!$body) $body = sprintf(LBL_EDIT_FORM_DEFAULT_BODY, $group['name']);
  $page['content'] .= "<form method='post'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $group_id . "'>\n";
  $page['content'] .= "<input type=hidden name='d2' value='1'>\n";
  $page['content'] .= "<input type='checkbox' name='inform' value='yes' onchange='toggle_details();'> " . LBL_EDIT_FORM_SEND_MAIL . "\n";
  $page['content'] .= "<span id='details' style='display: none;'><br><br>" . LBL_EDIT_FORM_SUBJECT . "<br>\n";
  $page['content'] .= "<input type=text name='subject' size='81' value='" . htmlspecialchars($subject, ENT_QUOTES) . "'><br><br>\n";
  $page['content'] .= LBL_EDIT_FORM_BODY . "<br>\n";
  $page['content'] .= "<textarea name='body' cols='80' rows='10'>" . htmlspecialchars($body, ENT_QUOTES) . "</textarea></span>\n";
  $page['content'] .= "<br><br><input type='submit' name='control' value='" . LBL_EDIT_FORM_DELETE . "'>\n";
  $page['content'] .= "</form>\n";

} else if ($control == LBL_EDIT_FORM_DELETE) {

  if ($inform == 'yes') {
    // Get all members before delete!
    if (($members = $gr->getGroupMembers($group_id)) == -1) {
      $page['errors'][] = ERROR_GROUPER_COMMUNICATE;
    }

    if (!source_connect($ldap)) {
      $page['errors'][] = ERROR_SOURCE_CONNECT;
      return;
    }

  }

  // Delete group
  if (!$gr->deleteGroup($group_id)) {
    $page['errors'][] .= ERROR_GROUPER_DELETEGROUP;
    return;
  }

  if ($inform == 'yes') {
    //$page['content'] .= "subject: $subject, body: $body<br>\n";

    $success = 1;

    // Find all mailadresses
    foreach ($members as $key => $member) {
      //$page['content'] .= "member: " . $member['id'] . "<br>\n";

      // Profile (from subject source)
      $profile = source_profile($ldap, $member['id']);
      if ($profile === FALSE) {
	    $page['errors'][] = ERROR_SOURCE_PROFILE;
        return;
      }

      // And mail everybody
      $displayname = $profile['cn'][0];

      for ($i = 0; $i < $profile['mail']['count']; $i++) {
	$address = $profile['mail'][$i];
	$page['content'] .= "$displayname: \n";

	if (!mail($address, $subject, $body, "From: systeembericht@surfteams.nl\r\nReply-To: systeembericht@surfteams.nl")) {
	  $page['content'] .= LBL_EDIT_MAIL_NOK . "<br>\n";
	  $success = 0;
	} else {
	  $page['content'] .= LBL_EDIT_MAIL_OK . "<br>\n";
	}
      }

    }
    if ($success) {
      $page['content'] .= LBL_EDIT_MAIL_SENT . "<br>\n";
    } else {
      $page['content'] .= LBL_EDIT_MAIL_FAIL . "<br>\n";
    }

  }

  $page['content'] .= "<a href=\"teams\">" . LBL_EDIT_RETURN . "</a><br>\n";

}
?>
